Index: src/backend/nodes/readfuncs.c
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/backend/nodes/readfuncs.c,v
retrieving revision 1.176
diff -c -r1.176 readfuncs.c
*** src/backend/nodes/readfuncs.c	6 Apr 2005 16:34:05 -0000	1.176
--- src/backend/nodes/readfuncs.c	18 Apr 2005 22:01:53 -0000
***************
*** 145,150 ****
--- 145,151 ----
  	READ_NODE_FIELD(rtable);
  	READ_NODE_FIELD(jointree);
  	READ_NODE_FIELD(rowMarks);
+ 	READ_BOOL_FIELD(forUpdate);
  	READ_NODE_FIELD(targetList);
  	READ_NODE_FIELD(groupClause);
  	READ_NODE_FIELD(havingQual);
Index: src/backend/optimizer/path/allpaths.c
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/backend/optimizer/path/allpaths.c,v
retrieving revision 1.125
diff -c -r1.125 allpaths.c
*** src/backend/optimizer/path/allpaths.c	6 Apr 2005 16:34:05 -0000	1.125
--- src/backend/optimizer/path/allpaths.c	18 Apr 2005 22:01:54 -0000
***************
*** 215,227 ****
  	ListCell   *il;
  
  	/*
! 	 * XXX for now, can't handle inherited expansion of FOR UPDATE; can we
  	 * do better?
  	 */
  	if (list_member_int(root->rowMarks, parentRTindex))
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 				 errmsg("SELECT FOR UPDATE is not supported for inheritance queries")));
  
  	/*
  	 * Initialize to compute size estimates for whole inheritance tree
--- 215,227 ----
  	ListCell   *il;
  
  	/*
! 	 * XXX for now, can't handle inherited expansion of FOR UPDATE/SHARE; can we
  	 * do better?
  	 */
  	if (list_member_int(root->rowMarks, parentRTindex))
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 				 errmsg("SELECT FOR UPDATE/SHARE is not supported for inheritance queries")));
  
  	/*
  	 * Initialize to compute size estimates for whole inheritance tree
Index: src/backend/optimizer/plan/initsplan.c
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/backend/optimizer/plan/initsplan.c,v
retrieving revision 1.104
diff -c -r1.104 initsplan.c
*** src/backend/optimizer/plan/initsplan.c	31 Dec 2004 22:00:09 -0000	1.104
--- src/backend/optimizer/plan/initsplan.c	16 Apr 2005 18:17:20 -0000
***************
*** 323,333 ****
  		Assert(bms_is_subset(rel->outerjoinset, outerrels));
  
  		/*
! 		 * Presently the executor cannot support FOR UPDATE marking of
  		 * rels appearing on the nullable side of an outer join. (It's
  		 * somewhat unclear what that would mean, anyway: what should we
  		 * mark when a result row is generated from no element of the
! 		 * nullable relation?)	So, complain if target rel is FOR UPDATE.
  		 * It's sufficient to make this check once per rel, so do it only
  		 * if rel wasn't already known nullable.
  		 */
--- 323,333 ----
  		Assert(bms_is_subset(rel->outerjoinset, outerrels));
  
  		/*
! 		 * Presently the executor cannot support FOR UPDATE/SHARE marking of
  		 * rels appearing on the nullable side of an outer join. (It's
  		 * somewhat unclear what that would mean, anyway: what should we
  		 * mark when a result row is generated from no element of the
! 		 * nullable relation?)	So, complain if target rel is FOR UPDATE/SHARE.
  		 * It's sufficient to make this check once per rel, so do it only
  		 * if rel wasn't already known nullable.
  		 */
***************
*** 336,342 ****
  			if (list_member_int(root->rowMarks, relno))
  				ereport(ERROR,
  						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 						 errmsg("SELECT FOR UPDATE cannot be applied to the nullable side of an outer join")));
  		}
  
  		rel->outerjoinset = outerrels;
--- 336,342 ----
  			if (list_member_int(root->rowMarks, relno))
  				ereport(ERROR,
  						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 						 errmsg("SELECT FOR UPDATE/SHARE cannot be applied to the nullable side of an outer join")));
  		}
  
  		rel->outerjoinset = outerrels;
Index: src/backend/optimizer/plan/planner.c
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/backend/optimizer/plan/planner.c,v
retrieving revision 1.184
diff -c -r1.184 planner.c
*** src/backend/optimizer/plan/planner.c	11 Apr 2005 23:06:55 -0000	1.184
--- src/backend/optimizer/plan/planner.c	18 Apr 2005 22:01:54 -0000
***************
*** 635,647 ****
  		tlist = postprocess_setop_tlist(result_plan->targetlist, tlist);
  
  		/*
! 		 * Can't handle FOR UPDATE here (parser should have checked
  		 * already, but let's make sure).
  		 */
  		if (parse->rowMarks)
  			ereport(ERROR,
  					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 					 errmsg("SELECT FOR UPDATE is not allowed with UNION/INTERSECT/EXCEPT")));
  
  		/*
  		 * Calculate pathkeys that represent result ordering requirements
--- 635,647 ----
  		tlist = postprocess_setop_tlist(result_plan->targetlist, tlist);
  
  		/*
! 		 * Can't handle FOR UPDATE/SHARE here (parser should have checked
  		 * already, but let's make sure).
  		 */
  		if (parse->rowMarks)
  			ereport(ERROR,
  					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 					 errmsg("SELECT FOR UPDATE/SHARE is not allowed with UNION/INTERSECT/EXCEPT")));
  
  		/*
  		 * Calculate pathkeys that represent result ordering requirements
Index: src/backend/optimizer/prep/prepjointree.c
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/backend/optimizer/prep/prepjointree.c,v
retrieving revision 1.26
diff -c -r1.26 prepjointree.c
*** src/backend/optimizer/prep/prepjointree.c	6 Apr 2005 16:34:06 -0000	1.26
--- src/backend/optimizer/prep/prepjointree.c	18 Apr 2005 22:01:54 -0000
***************
*** 276,286 ****
  			parse->rtable = list_concat(parse->rtable, subquery->rtable);
  
  			/*
! 			 * Pull up any FOR UPDATE markers, too.  (OffsetVarNodes
  			 * already adjusted the marker values, so just list_concat the
  			 * list.)
  			 */
  			parse->rowMarks = list_concat(parse->rowMarks, subquery->rowMarks);
  
  			/*
  			 * We also have to fix the relid sets of any parent
--- 276,287 ----
  			parse->rtable = list_concat(parse->rtable, subquery->rtable);
  
  			/*
! 			 * Pull up any FOR UPDATE/SHARE markers, too.  (OffsetVarNodes
  			 * already adjusted the marker values, so just list_concat the
  			 * list.)
  			 */
  			parse->rowMarks = list_concat(parse->rowMarks, subquery->rowMarks);
+ 			parse->forUpdate = subquery->forUpdate;
  
  			/*
  			 * We also have to fix the relid sets of any parent
Index: src/backend/optimizer/prep/preptlist.c
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/backend/optimizer/prep/preptlist.c,v
retrieving revision 1.74
diff -c -r1.74 preptlist.c
*** src/backend/optimizer/prep/preptlist.c	6 Apr 2005 16:34:06 -0000	1.74
--- src/backend/optimizer/prep/preptlist.c	18 Apr 2005 22:01:55 -0000
***************
*** 102,108 ****
  	}
  
  	/*
! 	 * Add TID targets for rels selected FOR UPDATE.  The executor
  	 * uses the TID to know which rows to lock, much as for UPDATE or
  	 * DELETE.
  	 */
--- 102,108 ----
  	}
  
  	/*
! 	 * Add TID targets for rels selected FOR UPDATE/SHARE.  The executor
  	 * uses the TID to know which rows to lock, much as for UPDATE or
  	 * DELETE.
  	 */
***************
*** 111,132 ****
  		ListCell   *l;
  
  		/*
! 		 * We've got trouble if the FOR UPDATE appears inside
  		 * grouping, since grouping renders a reference to individual
  		 * tuple CTIDs invalid.  This is also checked at parse time,
  		 * but that's insufficient because of rule substitution, query
  		 * pullup, etc.
  		 */
! 		CheckSelectForUpdate(parse);
  
  		/*
! 		 * Currently the executor only supports FOR UPDATE at top
  		 * level
  		 */
  		if (PlannerQueryLevel > 1)
  			ereport(ERROR,
  					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 					 errmsg("SELECT FOR UPDATE is not allowed in subqueries")));
  
  		foreach(l, parse->rowMarks)
  		{
--- 111,132 ----
  		ListCell   *l;
  
  		/*
! 		 * We've got trouble if the FOR UPDATE/SHARE appears inside
  		 * grouping, since grouping renders a reference to individual
  		 * tuple CTIDs invalid.  This is also checked at parse time,
  		 * but that's insufficient because of rule substitution, query
  		 * pullup, etc.
  		 */
! 		CheckSelectLocking(parse, parse->forUpdate);
  
  		/*
! 		 * Currently the executor only supports FOR UPDATE/SHARE at top
  		 * level
  		 */
  		if (PlannerQueryLevel > 1)
  			ereport(ERROR,
  					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 					 errmsg("SELECT FOR UPDATE/SHARE is not allowed in subqueries")));
  
  		foreach(l, parse->rowMarks)
  		{
Index: src/backend/parser/analyze.c
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/backend/parser/analyze.c,v
retrieving revision 1.320
diff -c -r1.320 analyze.c
*** src/backend/parser/analyze.c	14 Apr 2005 20:03:24 -0000	1.320
--- src/backend/parser/analyze.c	18 Apr 2005 22:01:55 -0000
***************
*** 134,140 ****
  					   bool isAddConstraint);
  static void applyColumnNames(List *dst, List *src);
  static List *getSetColTypes(ParseState *pstate, Node *node);
! static void transformForUpdate(Query *qry, List *forUpdate);
  static void transformConstraintAttrs(List *constraintList);
  static void transformColumnType(ParseState *pstate, ColumnDef *column);
  static void release_pstate_resources(ParseState *pstate);
--- 134,140 ----
  					   bool isAddConstraint);
  static void applyColumnNames(List *dst, List *src);
  static List *getSetColTypes(ParseState *pstate, Node *node);
! static void transformLockingClause(Query *qry, List *lockingClause);
  static void transformConstraintAttrs(List *constraintList);
  static void transformColumnType(ParseState *pstate, ColumnDef *column);
  static void release_pstate_resources(ParseState *pstate);
***************
*** 1810,1817 ****
  
  	qry->commandType = CMD_SELECT;
  
! 	/* make FOR UPDATE clause available to addRangeTableEntry */
! 	pstate->p_forUpdate = stmt->forUpdate;
  
  	/* process the FROM clause */
  	transformFromClause(pstate, stmt->fromClause);
--- 1810,1833 ----
  
  	qry->commandType = CMD_SELECT;
  
! 	/* make FOR UPDATE/FOR SHARE clause available to addRangeTableEntry */
! 	pstate->p_forUpdate = pstate->p_forShare = NULL;
! 
! 	if (stmt->lockingClause)
! 	{
! 		/*
! 		 * The first node in the list should be a T_String Value node
! 		 * containing "for_update" or "for_share"
! 		 */
! 		Value *type = linitial(stmt->lockingClause);
! 		
! 		if (strcmp(strVal(type), "for_update") == 0)
! 			pstate->p_forUpdate = list_copy_tail(stmt->lockingClause, 1);
! 		else if (strcmp(strVal(type), "for_share") == 0)
! 			pstate->p_forShare = list_copy_tail(stmt->lockingClause, 1);
! 		else
! 			elog(ERROR, "invalid first node in locking clause");
! 	}
  
  	/* process the FROM clause */
  	transformFromClause(pstate, stmt->fromClause);
***************
*** 1870,1877 ****
  	if (pstate->p_hasAggs || qry->groupClause || qry->havingQual)
  		parseCheckAggregates(pstate, qry);
  
! 	if (stmt->forUpdate != NIL)
! 		transformForUpdate(qry, stmt->forUpdate);
  
  	return qry;
  }
--- 1886,1893 ----
  	if (pstate->p_hasAggs || qry->groupClause || qry->havingQual)
  		parseCheckAggregates(pstate, qry);
  
! 	if (stmt->lockingClause != NIL)
! 		transformLockingClause(qry, stmt->lockingClause);
  
  	return qry;
  }
***************
*** 1899,1905 ****
  	List	   *sortClause;
  	Node	   *limitOffset;
  	Node	   *limitCount;
! 	List	   *forUpdate;
  	Node	   *node;
  	ListCell   *left_tlist,
  			   *dtlist;
--- 1915,1921 ----
  	List	   *sortClause;
  	Node	   *limitOffset;
  	Node	   *limitCount;
! 	List	   *lockingClause;
  	Node	   *node;
  	ListCell   *left_tlist,
  			   *dtlist;
***************
*** 1937,1954 ****
  	sortClause = stmt->sortClause;
  	limitOffset = stmt->limitOffset;
  	limitCount = stmt->limitCount;
! 	forUpdate = stmt->forUpdate;
  
  	stmt->sortClause = NIL;
  	stmt->limitOffset = NULL;
  	stmt->limitCount = NULL;
! 	stmt->forUpdate = NIL;
  
! 	/* We don't support forUpdate with set ops at the moment. */
! 	if (forUpdate)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 				 errmsg("SELECT FOR UPDATE is not allowed with UNION/INTERSECT/EXCEPT")));
  
  	/*
  	 * Recursively transform the components of the tree.
--- 1953,1970 ----
  	sortClause = stmt->sortClause;
  	limitOffset = stmt->limitOffset;
  	limitCount = stmt->limitCount;
! 	lockingClause = stmt->lockingClause;
  
  	stmt->sortClause = NIL;
  	stmt->limitOffset = NULL;
  	stmt->limitCount = NULL;
! 	stmt->lockingClause = NIL;
  
! 	/* We don't support FOR UPDATE/SHARE with set ops at the moment. */
! 	if (lockingClause)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 				 errmsg("SELECT FOR UPDATE/SHARE is not allowed with UNION/INTERSECT/EXCEPT")));
  
  	/*
  	 * Recursively transform the components of the tree.
***************
*** 2083,2090 ****
  	if (pstate->p_hasAggs || qry->groupClause || qry->havingQual)
  		parseCheckAggregates(pstate, qry);
  
! 	if (forUpdate != NIL)
! 		transformForUpdate(qry, forUpdate);
  
  	return qry;
  }
--- 2099,2106 ----
  	if (pstate->p_hasAggs || qry->groupClause || qry->havingQual)
  		parseCheckAggregates(pstate, qry);
  
! 	if (lockingClause != NIL)
! 		transformLockingClause(qry, lockingClause);
  
  	return qry;
  }
***************
*** 2107,2114 ****
  		ereport(ERROR,
  				(errcode(ERRCODE_SYNTAX_ERROR),
  				 errmsg("INTO is only allowed on first SELECT of UNION/INTERSECT/EXCEPT")));
! 	/* We don't support forUpdate with set ops at the moment. */
! 	if (stmt->forUpdate)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
  				 errmsg("SELECT FOR UPDATE is not allowed with UNION/INTERSECT/EXCEPT")));
--- 2123,2130 ----
  		ereport(ERROR,
  				(errcode(ERRCODE_SYNTAX_ERROR),
  				 errmsg("INTO is only allowed on first SELECT of UNION/INTERSECT/EXCEPT")));
! 	/* We don't support FOR UPDATE/SHARE with set ops at the moment. */
! 	if (stmt->lockingClause)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
  				 errmsg("SELECT FOR UPDATE is not allowed with UNION/INTERSECT/EXCEPT")));
***************
*** 2128,2134 ****
  	{
  		Assert(stmt->larg != NULL && stmt->rarg != NULL);
  		if (stmt->sortClause || stmt->limitOffset || stmt->limitCount ||
! 			stmt->forUpdate)
  			isLeaf = true;
  		else
  			isLeaf = false;
--- 2144,2150 ----
  	{
  		Assert(stmt->larg != NULL && stmt->rarg != NULL);
  		if (stmt->sortClause || stmt->limitOffset || stmt->limitCount ||
! 			stmt->lockingClause)
  			isLeaf = true;
  		else
  			isLeaf = false;
***************
*** 2711,2757 ****
  
  /* exported so planner can check again after rewriting, query pullup, etc */
  void
! CheckSelectForUpdate(Query *qry)
  {
  	if (qry->setOperations)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 				 errmsg("SELECT FOR UPDATE is not allowed with UNION/INTERSECT/EXCEPT")));
  	if (qry->distinctClause != NIL)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 		errmsg("SELECT FOR UPDATE is not allowed with DISTINCT clause")));
  	if (qry->groupClause != NIL)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 		errmsg("SELECT FOR UPDATE is not allowed with GROUP BY clause")));
  	if (qry->havingQual != NULL)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 		errmsg("SELECT FOR UPDATE is not allowed with HAVING clause")));
  	if (qry->hasAggs)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 				 errmsg("SELECT FOR UPDATE is not allowed with aggregate functions")));
  }
  
  /*
!  * Convert FOR UPDATE name list into rowMarks list of integer relids
   *
   * NB: if you need to change this, see also markQueryForUpdate()
   * in rewriteHandler.c.
   */
  static void
! transformForUpdate(Query *qry, List *forUpdate)
  {
! 	List	   *rowMarks = qry->rowMarks;
  	ListCell   *l;
  	ListCell   *rt;
  	Index		i;
  
! 	CheckSelectForUpdate(qry);
  
! 	if (linitial(forUpdate) == NULL)
  	{
  		/* all regular tables used in query */
  		i = 0;
--- 2727,2800 ----
  
  /* exported so planner can check again after rewriting, query pullup, etc */
  void
! CheckSelectLocking(Query *qry, bool forUpdate)
  {
+ 	char *operation;
+ 
+ 	if (forUpdate)
+ 		operation = "SELECT FOR UPDATE";
+ 	else
+ 		operation = "SELECT FOR SHARE";
+ 
  	if (qry->setOperations)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 				 /* translator: %s is a SQL command, like SELECT FOR UPDATE */
! 				 errmsg("%s is not allowed with UNION/INTERSECT/EXCEPT", operation)));
  	if (qry->distinctClause != NIL)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 				 /* translator: %s is a SQL command, like SELECT FOR UPDATE */
! 				 errmsg("%s is not allowed with DISTINCT clause", operation)));
  	if (qry->groupClause != NIL)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 				 /* translator: %s is a SQL command, like SELECT FOR UPDATE */
! 				 errmsg("%s is not allowed with GROUP BY clause", operation)));
  	if (qry->havingQual != NULL)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 				 /* translator: %s is a SQL command, like SELECT FOR UPDATE */
! 				 errmsg("%s is not allowed with HAVING clause", operation)));
  	if (qry->hasAggs)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 				 /* translator: %s is a SQL command, like SELECT FOR UPDATE */
! 				 errmsg("%s is not allowed with aggregate functions", operation)));
  }
  
  /*
!  * Convert FOR UPDATE/SHARE name list into rowMarks list of integer relids
   *
   * NB: if you need to change this, see also markQueryForUpdate()
   * in rewriteHandler.c.
   */
  static void
! transformLockingClause(Query *qry, List *lockingClause)
  {
! 	List	   *rowMarks;
  	ListCell   *l;
  	ListCell   *rt;
  	Index		i;
+ 	Value	   *type;
+ 	List	   *list_of_rels;
+ 
+ 	/* This should be a Value node containing "for_update" o "for_share" */
+ 	type = linitial(lockingClause);
+ 	if (strcmp(strVal(type), "for_update") == 0)
+ 		qry->forUpdate = true;
+ 	else if (strcmp(strVal(type), "for_share") == 0)
+ 		qry->forUpdate = false;
+ 	else
+ 		elog(ERROR, "invalid first node in locking clause");
+ 
+ 	CheckSelectLocking(qry, qry->forUpdate);
+ 	
+ 	rowMarks = qry->rowMarks;
  
! 	list_of_rels = list_copy_tail(lockingClause, 1);
  
! 	if (linitial(list_of_rels) == NULL)
  	{
  		/* all regular tables used in query */
  		i = 0;
***************
*** 2773,2779 ****
  					 * FOR UPDATE of subquery is propagated to subquery's
  					 * rels
  					 */
! 					transformForUpdate(rte->subquery, list_make1(NULL));
  					break;
  				default:
  					/* ignore JOIN, SPECIAL, FUNCTION RTEs */
--- 2816,2822 ----
  					 * FOR UPDATE of subquery is propagated to subquery's
  					 * rels
  					 */
! 					transformLockingClause(rte->subquery, lcons(type, list_make1(NULL)));
  					break;
  				default:
  					/* ignore JOIN, SPECIAL, FUNCTION RTEs */
***************
*** 2784,2790 ****
  	else
  	{
  		/* just the named tables */
! 		foreach(l, forUpdate)
  		{
  			char	   *relname = strVal(lfirst(l));
  
--- 2827,2833 ----
  	else
  	{
  		/* just the named tables */
! 		foreach(l, list_of_rels)
  		{
  			char	   *relname = strVal(lfirst(l));
  
***************
*** 2809,2815 ****
  							 * FOR UPDATE of subquery is propagated to
  							 * subquery's rels
  							 */
! 							transformForUpdate(rte->subquery, list_make1(NULL));
  							break;
  						case RTE_JOIN:
  							ereport(ERROR,
--- 2852,2858 ----
  							 * FOR UPDATE of subquery is propagated to
  							 * subquery's rels
  							 */
! 							transformLockingClause(rte->subquery, lcons(type, list_make1(NULL)));
  							break;
  						case RTE_JOIN:
  							ereport(ERROR,
Index: src/backend/parser/gram.y
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/backend/parser/gram.y,v
retrieving revision 2.487
diff -c -r2.487 gram.y
*** src/backend/parser/gram.y	7 Apr 2005 01:51:38 -0000	2.487
--- src/backend/parser/gram.y	18 Apr 2005 22:01:55 -0000
***************
*** 87,93 ****
  static List *extractArgTypes(List *parameters);
  static SelectStmt *findLeftmostSelect(SelectStmt *node);
  static void insertSelectOptions(SelectStmt *stmt,
! 								List *sortClause, List *forUpdate,
  								Node *limitOffset, Node *limitCount);
  static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
  static Node *doNegate(Node *n);
--- 87,93 ----
  static List *extractArgTypes(List *parameters);
  static SelectStmt *findLeftmostSelect(SelectStmt *node);
  static void insertSelectOptions(SelectStmt *stmt,
! 								List *sortClause, List *lockingClause,
  								Node *limitOffset, Node *limitCount);
  static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
  static Node *doNegate(Node *n);
***************
*** 242,248 ****
  %type <oncommit> OnCommitOption
  %type <withoids> OptWithOids WithOidsAs
  
! %type <list>	for_update_clause opt_for_update_clause update_list
  %type <boolean>	opt_all
  
  %type <node>	join_outer join_qual
--- 242,249 ----
  %type <oncommit> OnCommitOption
  %type <withoids> OptWithOids WithOidsAs
  
! %type <list>	for_locking_clause opt_for_locking_clause
! 				update_list
  %type <boolean>	opt_all
  
  %type <node>	join_outer join_qual
***************
*** 4886,4894 ****
  		;
  
  /*
!  *	FOR UPDATE may be before or after LIMIT/OFFSET.
   *	In <=7.2.X, LIMIT/OFFSET had to be after FOR UPDATE
!  *	We now support both orderings, but prefer LIMIT/OFFSET before FOR UPDATE
   *	2002-08-28 bjm
   */
  select_no_parens:
--- 4887,4895 ----
  		;
  
  /*
!  *	FOR UPDATE/SHARE may be before or after LIMIT/OFFSET.
   *	In <=7.2.X, LIMIT/OFFSET had to be after FOR UPDATE
!  *	We now support both orderings, but prefer LIMIT/OFFSET before FOR UPDATE/SHARE
   *	2002-08-28 bjm
   */
  select_no_parens:
***************
*** 4899,4911 ****
  										NULL, NULL);
  					$$ = $1;
  				}
! 			| select_clause opt_sort_clause for_update_clause opt_select_limit
  				{
  					insertSelectOptions((SelectStmt *) $1, $2, $3,
  										list_nth($4, 0), list_nth($4, 1));
  					$$ = $1;
  				}
! 			| select_clause opt_sort_clause select_limit opt_for_update_clause
  				{
  					insertSelectOptions((SelectStmt *) $1, $2, $4,
  										list_nth($3, 0), list_nth($3, 1));
--- 4900,4912 ----
  										NULL, NULL);
  					$$ = $1;
  				}
! 			| select_clause opt_sort_clause for_locking_clause opt_select_limit
  				{
  					insertSelectOptions((SelectStmt *) $1, $2, $3,
  										list_nth($4, 0), list_nth($4, 1));
  					$$ = $1;
  				}
! 			| select_clause opt_sort_clause select_limit opt_for_locking_clause
  				{
  					insertSelectOptions((SelectStmt *) $1, $2, $4,
  										list_nth($3, 0), list_nth($3, 1));
***************
*** 5146,5158 ****
  			| /*EMPTY*/								{ $$ = NULL; }
  		;
  
! for_update_clause:
! 			FOR UPDATE update_list					{ $$ = $3; }
  			| FOR READ ONLY							{ $$ = NULL; }
  		;
  
! opt_for_update_clause:
! 			for_update_clause						{ $$ = $1; }
  			| /* EMPTY */							{ $$ = NULL; }
  		;
  
--- 5147,5160 ----
  			| /*EMPTY*/								{ $$ = NULL; }
  		;
  
! for_locking_clause:
! 			FOR SHARE update_list					{ $$ = lcons(makeString("for_share"), $3); }
! 			| FOR UPDATE update_list				{ $$ = lcons(makeString("for_update"), $3); }
  			| FOR READ ONLY							{ $$ = NULL; }
  		;
  
! opt_for_locking_clause:
! 			for_locking_clause						{ $$ = $1; }
  			| /* EMPTY */							{ $$ = NULL; }
  		;
  
***************
*** 8379,8385 ****
   */
  static void
  insertSelectOptions(SelectStmt *stmt,
! 					List *sortClause, List *forUpdate,
  					Node *limitOffset, Node *limitCount)
  {
  	/*
--- 8381,8387 ----
   */
  static void
  insertSelectOptions(SelectStmt *stmt,
! 					List *sortClause, List *lockingClause,
  					Node *limitOffset, Node *limitCount)
  {
  	/*
***************
*** 8394,8406 ****
  					 errmsg("multiple ORDER BY clauses not allowed")));
  		stmt->sortClause = sortClause;
  	}
! 	if (forUpdate)
  	{
! 		if (stmt->forUpdate)
  			ereport(ERROR,
  					(errcode(ERRCODE_SYNTAX_ERROR),
! 					 errmsg("multiple FOR UPDATE clauses not allowed")));
! 		stmt->forUpdate = forUpdate;
  	}
  	if (limitOffset)
  	{
--- 8396,8408 ----
  					 errmsg("multiple ORDER BY clauses not allowed")));
  		stmt->sortClause = sortClause;
  	}
! 	if (lockingClause)
  	{
! 		if (stmt->lockingClause)
  			ereport(ERROR,
  					(errcode(ERRCODE_SYNTAX_ERROR),
! 					 errmsg("multiple FOR UPDATE/FOR SHARE clauses not allowed")));
! 		stmt->lockingClause = lockingClause;
  	}
  	if (limitOffset)
  	{
Index: src/backend/parser/parse_relation.c
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/backend/parser/parse_relation.c,v
retrieving revision 1.106
diff -c -r1.106 parse_relation.c
*** src/backend/parser/parse_relation.c	13 Apr 2005 16:50:55 -0000	1.106
--- src/backend/parser/parse_relation.c	18 Apr 2005 22:08:39 -0000
***************
*** 40,46 ****
--- 40,48 ----
  					  Oid relid);
  static void scanNameSpaceForConflict(ParseState *pstate, Node *nsnode,
  						 RangeTblEntry *rte1, const char *aliasname1);
+ static bool isForLocking(List *list, char *refname);
  static bool isForUpdate(ParseState *pstate, char *refname);
+ static bool isForShare(ParseState *pstate, char *refname);
  static void expandRelation(Oid relid, Alias *eref,
  			   int rtindex, int sublevels_up,
  			   bool include_dropped,
***************
*** 761,767 ****
  	 * first access to a rel in a statement, be careful to get the right
  	 * access level depending on whether we're doing SELECT FOR UPDATE.
  	 */
! 	lockmode = isForUpdate(pstate, refname) ? RowShareLock : AccessShareLock;
  	rel = heap_openrv(relation, lockmode);
  	rte->relid = RelationGetRelid(rel);
  
--- 763,770 ----
  	 * first access to a rel in a statement, be careful to get the right
  	 * access level depending on whether we're doing SELECT FOR UPDATE.
  	 */
! 	lockmode = (isForUpdate(pstate, refname) || isForShare(pstate, refname)) ?
! 				RowShareLock : AccessShareLock;
  	rel = heap_openrv(relation, lockmode);
  	rte->relid = RelationGetRelid(rel);
  
***************
*** 1121,1126 ****
--- 1124,1160 ----
  }
  
  /*
+  * Workhorse for isForUpdate and isForShare
+  */
+ static bool
+ isForLocking(List *list, char *refname)
+ {
+ 	if (list != NIL)
+ 	{
+ 		if (linitial(list) == NULL)
+ 		{
+ 			/* all tables used in query */
+ 			return true;
+ 		}
+ 		else
+ 		{
+ 			/* just the named tables */
+ 			ListCell   *cell;
+ 
+ 			foreach(cell, list)
+ 			{
+ 				char	   *rname = strVal(lfirst(cell));
+ 
+ 				if (strcmp(refname, rname) == 0)
+ 					return true;
+ 			}
+ 		}
+ 	}
+ 	return false;
+ }
+ 
+ 
+ /*
   * Has the specified refname been selected FOR UPDATE?
   */
  static bool
***************
*** 1129,1155 ****
  	/* Outer loop to check parent query levels as well as this one */
  	while (pstate != NULL)
  	{
! 		if (pstate->p_forUpdate != NIL)
! 		{
! 			if (linitial(pstate->p_forUpdate) == NULL)
! 			{
! 				/* all tables used in query */
! 				return true;
! 			}
! 			else
! 			{
! 				/* just the named tables */
! 				ListCell   *l;
  
! 				foreach(l, pstate->p_forUpdate)
! 				{
! 					char	   *rname = strVal(lfirst(l));
  
- 					if (strcmp(refname, rname) == 0)
- 						return true;
- 				}
- 			}
- 		}
  		pstate = pstate->parentParseState;
  	}
  	return false;
--- 1163,1188 ----
  	/* Outer loop to check parent query levels as well as this one */
  	while (pstate != NULL)
  	{
! 		if (isForLocking(pstate->p_forUpdate, refname))
! 			return true;
  
! 		pstate = pstate->parentParseState;
! 	}
! 	return false;
! }
! 
! /*
!  * Has the specified refname been selected FOR SHARE?
!  */
! static bool
! isForShare(ParseState *pstate, char *refname)
! {
! 	/* Outer loop to check parent query levels as well as this one */
! 	while (pstate != NULL)
! 	{
! 		if (isForLocking(pstate->p_forUpdate, refname))
! 			return true;
  
  		pstate = pstate->parentParseState;
  	}
  	return false;
Index: src/backend/parser/parse_type.c
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/backend/parser/parse_type.c,v
retrieving revision 1.73
diff -c -r1.73 parse_type.c
*** src/backend/parser/parse_type.c	31 Dec 2004 22:00:27 -0000	1.73
--- src/backend/parser/parse_type.c	16 Apr 2005 18:17:20 -0000
***************
*** 432,438 ****
  		stmt->sortClause != NIL ||
  		stmt->limitOffset != NULL ||
  		stmt->limitCount != NULL ||
! 		stmt->forUpdate != NIL ||
  		stmt->op != SETOP_NONE)
  		goto fail;
  	if (list_length(stmt->targetList) != 1)
--- 432,438 ----
  		stmt->sortClause != NIL ||
  		stmt->limitOffset != NULL ||
  		stmt->limitCount != NULL ||
! 		stmt->lockingClause != NIL ||
  		stmt->op != SETOP_NONE)
  		goto fail;
  	if (list_length(stmt->targetList) != 1)
